
#include "shape.h"
#include "rect.h"
#include "circle.h"
#include "copper.h"

int main(int argc, char *argv[])
{
    struct _rect *rect = rect_new(4, 5);
    rect_area(rect, rect);
    rect_draw(rect, rect);

    struct _circle *circle = circle_new(3);
    circle_area(circle, circle);
    circle_draw(circle, circle);

    printf("----- rect & circle -----\n");
    shape_area(rect, rect->shape);
    shape_draw(rect, rect->shape);

    shape_area(circle, circle->shape);
    shape_draw(circle, circle->shape);

    printf("----- [2] rect & circle -----\n");
    struct _rect *rect2 = (struct _rect *)rect_new(2, 3);
    shape_area(rect2, rect2->shape);
    shape_draw(rect2, rect2->shape);

    struct _circle *circle2 = (struct _circle *)circle_new(1);
    shape_area(circle2, circle->shape);
    shape_draw(circle2, circle->shape);

    // printf("----- [2] shape -----\n");
    // struct _shape *shape = shape_new();
    // shape_area(shape, shape);
    // shape_draw(shape, shape);

    printf("----- copper_cash -----\n");
    struct _copper_cash *cc = copper_cash_new(2, 2, 4);
    shape_area(cc, cc->shape);
    shape_draw(cc, cc->shape);

    printf("----- [2] copper_cash -----\n");
    rect_area(cc, cc->rect);
    rect_draw(cc, cc->rect);

    circle_area(cc, cc->circle);
    circle_draw(cc, cc->circle);

    return 0;
}
