
#ifndef _COPPER_CASH_H_
#define _COPPER_CASH_H_

#include "common.h"
#include "shape.h"
#include "rect.h"
#include "circle.h"

struct _copper_cash
{
    struct _copper_cash *self;

    struct _shape *shape;
    struct _rect *rect;
    struct _circle *circle;

    double price;
};

struct _copper_cash *copper_cash_new(double width, double height, double radius);

double copper_cash_area(struct _copper_cash *self, void *parent);
void copper_cash_draw(struct _copper_cash *self, void *parent);

#endif
